:- module(avltrees,[]).  %% converted djd
:- style_check(-singleton). % added djd

% Copyright (C) Goedel Group, University of Bristol, June 1992.
% Title and ownership of all Goedel software originating from the Goedel
% Group at the University of Bristol remains with the Goedel Group.
%
% The Goedel language was designed by P.M. Hill and J.W. Lloyd, and the 
% language was implemented by A. Bowers and J. Wang. The design and 
% implementation of the language was partly supported by the ESPRIT Basic 
% Research Action 3012 (Compulog), a SERC Grant GR/F/26256, and the 
% University of Bristol.
%
% This software is available ONLY for research and educational purposes.
% In particular, it may not be used for any commercial purpose whatsoever.
% The software is free and is provided "as is", without warranty of any kind.
% Users of the software are free to modify and experiment with it for 
% research and educational purposes. However, users may not distribute 
% the software (modified or not) to third parties without the express 
% permission of the Goedel Group. The normal method of obtaining this 
% software is by ftp from ftp.cs.kuleuven.ac.be.
%
% Any enquiries about this copyright notice or the use of this software 
% should be directed to J.W. Lloyd at jwl@compsci.bristol.ac.uk.


/* 
Subject:	the compiled avlTree routines.
Date:		20 Feb 1992
	
================================================================================
*/

%% '$$module'('@(#)avltrees.pl 1.5 last updated 93/05/20 18:13:38 by jiwei').


'avlTrees.adjustment.p4'('avlTrees.eq.c0', 'avlTrees.left.c0', 'avlTrees.lh.c0', 'avlTrees.no.c0') :- !.
'avlTrees.adjustment.p4'('avlTrees.eq.c0', 'avlTrees.right.c0', 'avlTrees.rh.c0', 'avlTrees.no.c0') :- !.
'avlTrees.adjustment.p4'('avlTrees.lh.c0', 'avlTrees.left.c0', _, 'avlTrees.yes.c0') :- !.
'avlTrees.adjustment.p4'('avlTrees.lh.c0', 'avlTrees.right.c0', 'avlTrees.eq.c0', 'avlTrees.no.c0') :- !.
'avlTrees.adjustment.p4'('avlTrees.rh.c0', 'avlTrees.left.c0', 'avlTrees.eq.c0', 'avlTrees.no.c0') :- !.
'avlTrees.adjustment.p4'('avlTrees.rh.c0', 'avlTrees.right.c0', _, 'avlTrees.yes.c0') :- !.
'avlTrees.avlJoin.p3'(A, B, C) :-
        'avlTrees.avlJoinAux.p3'(B, A, C).
'avlTrees.avlInsert.p4'(A, B, C, D) :-
        'avlTrees.insert.p5'(A, B, C, D, _).
'avlTrees.avlAmend.p6'(A, B, C, D, E, F) :-
        'avlTrees.amend.p7'(A, B, C, D, E, F, _).
'avlTrees.avlDelete.p3'(A, B, C) :-
        'avlTrees.deleteKey.p4'(A, B, C, _).
'avlTrees.avlIsEmpty.p1'('avlTrees.null.c0').
'avlTrees.avlSearch.p3'('avlTrees.node.f5'(_,A,B,_,_), C, D) :-
        call_residue(C=A, E),
        (   E=[] ->
            true
        ;   user:flounder_commit(E)
        ), !,
        D=B.
'avlTrees.avlSearch.p3'('avlTrees.node.f5'(A,B,_,_,_), C, D) :-
        call_residue('strings.<.p2'(C,B), E),
        (   E=[] ->
            true
        ;   user:flounder_commit(E)
        ), !,
        'avlTrees.avlSearch.p3'(A, C, D).
'avlTrees.avlSearch.p3'('avlTrees.node.f5'(_,A,_,_,B), C, D) :-
        call_residue('strings.>.p2'(C,A), E),
        (   E=[] ->
            true
        ;   user:flounder_commit(E)
        ), !,
        'avlTrees.avlSearch.p3'(B, C, D).
'avlTrees.avlMember.p3'('avlTrees.node.f5'(_,A,B,_,_), A, B).
'avlTrees.avlMember.p3'('avlTrees.node.f5'(A,_,_,_,_), B, C) :-
        'avlTrees.avlMember.p3'(A, B, C).
'avlTrees.avlMember.p3'('avlTrees.node.f5'(_,_,_,_,A), B, C) :-
        'avlTrees.avlMember.p3'(A, B, C).
'avlTrees.avlJoinAux.p3'('avlTrees.null.c0', A, A).
'avlTrees.avlJoinAux.p3'('avlTrees.node.f5'(A,B,C,_,D), E, F) :-
        'avlTrees.amend.p7'(E, B, C, _, G, _, _),
        'avlTrees.avlJoinAux.p3'(A, G, H),
        'avlTrees.avlJoinAux.p3'(D, H, F).
'avlTrees.avlUpdate.p5'('avlTrees.node.f5'(A,B,C,D,E), F, G, H, I) :-
        call_residue(F=B, J),
        (   J=[] ->
            true
        ;   user:flounder_commit(J)
        ), !,
        H='avlTrees.node.f5'(A,B,G,D,E),
        I=C.
'avlTrees.avlUpdate.p5'('avlTrees.node.f5'(A,B,C,D,E), F, G, H, I) :-
        call_residue('strings.<.p2'(F,B), J),
        (   J=[] ->
            true
        ;   user:flounder_commit(J)
        ), !,
        'avlTrees.avlUpdate.p5'(A, F, G, K, I),
        H='avlTrees.node.f5'(K,B,C,D,E).
'avlTrees.avlUpdate.p5'('avlTrees.node.f5'(A,B,C,D,E), F, G, H, I) :-
        call_residue('strings.>.p2'(F,B), J),
        (   J=[] ->
            true
        ;   user:flounder_commit(J)
        ), !,
        'avlTrees.avlUpdate.p5'(E, F, G, K, I),
        H='avlTrees.node.f5'(A,B,C,D,K).
'avlTrees.avlToBinary.p2'('avlTrees.null.c0', 'avlTrees.empty.c0').
'avlTrees.avlToBinary.p2'('avlTrees.node.f5'(A,B,C,_,D), 'avlTrees.tree.f4'(E,B,C,F)) :-
        'avlTrees.avlToBinary.p2'(A, E),
        'avlTrees.avlToBinary.p2'(D, F).
'avlTrees.adjust.p6'('avlTrees.no.c0', A, B, _, B, A).
'avlTrees.adjust.p6'('avlTrees.yes.c0', A, B, C, D, E) :-
        'avlTrees.adjustment.p4'(B, C, D, F),
        'avlTrees.rebalance.p4'(F, A, D, E).
'avlTrees.deleteKey.p4'('avlTrees.node.f5'(A,B,C,D,E), F, G, H) :-
        call_residue('strings.<.p2'(F,B), I),
        (   I=[] ->
            true
        ;   user:flounder_commit(I)
        ), !,
        'avlTrees.deleteKey.p4'(A, F, J, K),
        'avlTrees.adjust.p6'(K, 'avlTrees.node.f5'(J,B,C,D,E), D, 'avlTrees.right.c0', L, G),
        'avlTrees.heightDecreased.p3'(D, L, H).
'avlTrees.deleteKey.p4'('avlTrees.node.f5'(A,B,C,D,E), F, G, H) :-
        call_residue('strings.>.p2'(F,B), I),
        (   I=[] ->
            true
        ;   user:flounder_commit(I)
        ), !,
        'avlTrees.deleteKey.p4'(E, F, J, K),
        'avlTrees.adjust.p6'(K, 'avlTrees.node.f5'(A,B,C,D,J), D, 'avlTrees.left.c0', L, G),
        'avlTrees.heightDecreased.p3'(D, L, H).
'avlTrees.deleteKey.p4'('avlTrees.node.f5'(A,B,_,C,D), E, F, G) :-
        call_residue(E=B, H),
        (   H=[] ->
            true
        ;   user:flounder_commit(H)
        ), !,
        'avlTrees.combine.p5'(A, C, D, F, G).
'avlTrees.balanceTable2.p3'('avlTrees.lh.c0', 'avlTrees.eq.c0', 'avlTrees.rh.c0').
'avlTrees.balanceTable2.p3'('avlTrees.rh.c0', 'avlTrees.lh.c0', 'avlTrees.eq.c0').
'avlTrees.balanceTable2.p3'('avlTrees.eq.c0', 'avlTrees.eq.c0', 'avlTrees.eq.c0').
'avlTrees.balanceTable1.p3'('avlTrees.eq.c0', 'avlTrees.rh.c0', 'avlTrees.lh.c0').
'avlTrees.balanceTable1.p3'('avlTrees.lh.c0', 'avlTrees.eq.c0', 'avlTrees.eq.c0').
'avlTrees.balanceTable1.p3'('avlTrees.rh.c0', 'avlTrees.eq.c0', 'avlTrees.eq.c0').
'avlTrees.amend.p7'('avlTrees.null.c0', A, B, C, 'avlTrees.node.f5'('avlTrees.null.c0',A,B,'avlTrees.eq.c0','avlTrees.null.c0'), C, 'avlTrees.yes.c0').
'avlTrees.amend.p7'('avlTrees.node.f5'(A,B,C,D,E), F, G, H, I, J, K) :-
        call_residue('strings.<.p2'(F,B), L),
        (   L=[] ->
            true
        ;   user:flounder_commit(L)
        ), !,
        'avlTrees.amend.p7'(A, F, G, H, M, J, N),
        'avlTrees.adjust.p6'(N, 'avlTrees.node.f5'(M,B,C,D,E), D, 'avlTrees.left.c0', O, I),
        'avlTrees.heightIncreased.p3'(D, O, K).
'avlTrees.amend.p7'('avlTrees.node.f5'(A,B,C,D,E), F, G, H, I, J, K) :-
        call_residue('strings.>.p2'(F,B), L),
        (   L=[] ->
            true
        ;   user:flounder_commit(L)
        ), !,
        'avlTrees.amend.p7'(E, F, G, H, M, J, N),
        'avlTrees.adjust.p6'(N, 'avlTrees.node.f5'(A,B,C,D,M), D, 'avlTrees.right.c0', O, I),
        'avlTrees.heightIncreased.p3'(D, O, K).
'avlTrees.amend.p7'('avlTrees.node.f5'(A,B,C,D,E), F, G, _, H, I, J) :-
        call_residue(F=B, K),
        (   K=[] ->
            true
        ;   user:flounder_commit(K)
        ), !,
        H='avlTrees.node.f5'(A,F,G,D,E),
        I=C,
        J='avlTrees.no.c0'.
'avlTrees.combine.p5'('avlTrees.null.c0', _, A, A, 'avlTrees.yes.c0') :- !.
'avlTrees.combine.p5'(A, _, 'avlTrees.null.c0', A, 'avlTrees.yes.c0') :- !.
'avlTrees.combine.p5'(A, B, C, D, E) :-
        call_residue((user:not_equal([],[A],A,'avlTrees.null.c0'),user:not_equal([],[C],C,'avlTrees.null.c0')), F),
        (   F=[] ->
            true
        ;   user:flounder_commit(F)
        ), !,
        'avlTrees.removerightmost.p5'(A, G, H, I, J),
        'avlTrees.adjust.p6'(J, 'avlTrees.node.f5'(I,G,H,B,C), B, 'avlTrees.right.c0', K, D),
        'avlTrees.heightDecreased.p3'(B, K, E).
'avlTrees.insert.p5'('avlTrees.null.c0', A, B, 'avlTrees.node.f5'('avlTrees.null.c0',A,B,'avlTrees.eq.c0','avlTrees.null.c0'), 'avlTrees.yes.c0').
'avlTrees.insert.p5'('avlTrees.node.f5'(A,B,C,D,E), F, G, H, I) :-
        call_residue('strings.<.p2'(F,B), J),
        (   J=[] ->
            true
        ;   user:flounder_commit(J)
        ), !,
        'avlTrees.insert.p5'(A, F, G, K, L),
        'avlTrees.adjust.p6'(L, 'avlTrees.node.f5'(K,B,C,D,E), D, 'avlTrees.left.c0', M, H),
        'avlTrees.heightIncreased.p3'(D, M, I).
'avlTrees.insert.p5'('avlTrees.node.f5'(A,B,C,D,E), F, G, H, I) :-
        call_residue('strings.>.p2'(F,B), J),
        (   J=[] ->
            true
        ;   user:flounder_commit(J)
        ), !,
        'avlTrees.insert.p5'(E, F, G, K, L),
        'avlTrees.adjust.p6'(L, 'avlTrees.node.f5'(A,B,C,D,K), D, 'avlTrees.right.c0', M, H),
        'avlTrees.heightIncreased.p3'(D, M, I).
'avlTrees.insert.p5'('avlTrees.node.f5'(A,B,C,D,E), F, G, H, I) :-
        call_residue(F=B, J),
        (   J=[] ->
            true
        ;   user:flounder_commit(J)
        ), !,
        G=C,
        H='avlTrees.node.f5'(A,B,C,D,E),
        I='avlTrees.no.c0'.
'avlTrees.heightIncreased.p3'('avlTrees.rh.c0', 'avlTrees.eq.c0', 'avlTrees.no.c0') :- !.
'avlTrees.heightIncreased.p3'('avlTrees.lh.c0', 'avlTrees.eq.c0', 'avlTrees.no.c0') :- !.
'avlTrees.heightIncreased.p3'('avlTrees.eq.c0', 'avlTrees.lh.c0', 'avlTrees.yes.c0') :- !.
'avlTrees.heightIncreased.p3'('avlTrees.eq.c0', 'avlTrees.rh.c0', 'avlTrees.yes.c0') :- !.
'avlTrees.heightIncreased.p3'(A, A, 'avlTrees.no.c0') :- !.
'avlTrees.heightDecreased.p3'('avlTrees.lh.c0', 'avlTrees.rh.c0', 'avlTrees.no.c0') :- !.
'avlTrees.heightDecreased.p3'('avlTrees.rh.c0', 'avlTrees.lh.c0', 'avlTrees.no.c0') :- !.
'avlTrees.heightDecreased.p3'('avlTrees.lh.c0', 'avlTrees.eq.c0', 'avlTrees.yes.c0') :- !.
'avlTrees.heightDecreased.p3'('avlTrees.rh.c0', 'avlTrees.eq.c0', 'avlTrees.yes.c0') :- !.
'avlTrees.heightDecreased.p3'('avlTrees.eq.c0', _, 'avlTrees.no.c0') :- !.
'avlTrees.heightDecreased.p3'(A, A, 'avlTrees.no.c0') :- !.
'avlTrees.removerightmost.p5'('avlTrees.node.f5'(A,B,C,D,E), F, G, H, I) :-
        call_residue(user:not_equal([],[E],E,'avlTrees.null.c0'), J),
        (   J=[] ->
            true
        ;   user:flounder_commit(J)
        ), !,
        'avlTrees.removerightmost.p5'(E, F, G, K, L),
        'avlTrees.adjust.p6'(L, 'avlTrees.node.f5'(A,B,C,D,K), D, 'avlTrees.left.c0', M, H),
        'avlTrees.heightDecreased.p3'(D, M, I).
'avlTrees.removerightmost.p5'('avlTrees.node.f5'(A,B,C,_,'avlTrees.null.c0'), B, C, A, 'avlTrees.yes.c0') :- !.
'avlTrees.rebalance.p4'('avlTrees.no.c0', 'avlTrees.node.f5'(A,B,C,_,D), E, 'avlTrees.node.f5'(A,B,C,E,D)).
'avlTrees.rebalance.p4'('avlTrees.yes.c0', A, B, C) :-
        'avlTrees.restructure.p3'(A, B, C).
'avlTrees.restructure.p3'('avlTrees.node.f5'(A,B,C,'avlTrees.rh.c0','avlTrees.node.f5'(D,E,F,G,H)), I, J) :-
        call_residue(user:not_equal([],[G],G,'avlTrees.lh.c0'), K),
        (   K=[] ->
            true
        ;   user:flounder_commit(K)
        ), !,
        J='avlTrees.node.f5'('avlTrees.node.f5'(A,B,C,L,D),E,F,I,H),
        'avlTrees.balanceTable1.p3'(G, L, I).
'avlTrees.restructure.p3'('avlTrees.node.f5'('avlTrees.node.f5'(A,B,C,D,E),F,G,'avlTrees.lh.c0',H), I, J) :-
        call_residue(user:not_equal([],[D],D,'avlTrees.rh.c0'), K),
        (   K=[] ->
            true
        ;   user:flounder_commit(K)
        ), !,
        J='avlTrees.node.f5'(A,B,C,I,'avlTrees.node.f5'(E,F,G,L,H)),
        'avlTrees.balanceTable1.p3'(D, I, L).
'avlTrees.restructure.p3'('avlTrees.node.f5'(A,B,C,'avlTrees.rh.c0','avlTrees.node.f5'('avlTrees.node.f5'(D,E,F,G,H),I,J,'avlTrees.lh.c0',K)), 'avlTrees.eq.c0', 'avlTrees.node.f5'('avlTrees.node.f5'(A,B,C,L,D),E,F,'avlTrees.eq.c0','avlTrees.node.f5'(H,I,J,M,K))) :- !,
        'avlTrees.balanceTable2.p3'(G, L, M).
'avlTrees.restructure.p3'('avlTrees.node.f5'('avlTrees.node.f5'(A,B,C,'avlTrees.rh.c0','avlTrees.node.f5'(D,E,F,G,H)),I,J,'avlTrees.lh.c0',K), 'avlTrees.eq.c0', 'avlTrees.node.f5'('avlTrees.node.f5'(A,B,C,L,D),E,F,'avlTrees.eq.c0','avlTrees.node.f5'(H,I,J,M,K))) :- !,
        'avlTrees.balanceTable2.p3'(G, L, M).
